﻿(*
  Component Initializer

  Copyright (c) 2014-2018 Lyna

  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
    claim that you wrote the original software. If you use this software
    in a product, an acknowledgment in the product documentation would be
    appreciated but is not required.

    2. Altered source versions must be plainly marked as such, and must not be
    misrepresented as being the original software.

    3. This notice may not be removed or altered from any source
    distribution.
*)
unit UHook;

interface

uses
{$IF CompilerVersion >= 23.00}
  Winapi.Windows, System.Classes, DDetours;
{$ELSE}
  Windows, Classes, DDetours;
{$IFEND}

implementation

uses
  UMain;

var
  Hooked: Boolean;
  CreateCurrentComponentAddr: Pointer;
  TrampolineCreateCurrentComponent: function(Self, Parent: TComponent; const Rect: TRect): TComponent;

function MyCreateCurrentComponent(Self, Parent: TComponent; const Rect: TRect): TComponent;
begin
  Result := TrampolineCreateCurrentComponent(Self, Parent, Rect);
  if Result <> nil then
    OnCreateComponent(Result, Parent, Rect);
end;

const
  TargetName =
{$IF CompilerVersion >= 23.00}
    {XE2-}'@Componentdesigner@TComponentRoot@CreateCurrentComponent$qqrp25System@Classes@TComponentrx18System@Types@TRect';
{$ELSE}
    {-XE}'@Componentdesigner@TComponentRoot@CreateCurrentComponent$qqrp18Classes@TComponentrx11Types@TRect';
{$IFEND}
  PackageName = {$IFDEF VER140}'designide60.bpl';{$ENDIF}
                {$IFDEF VER150}'designide70.bpl';{$ENDIF}
                {$IFDEF VER160}'designide80.bpl';{$ENDIF}
                {$IFDEF VER170}'designide90.bpl';{$ENDIF}
                {$IFDEF VER180}'designide100.bpl';{$ENDIF}
                {$IFDEF VER185}'designide110.bpl';{$ENDIF}
                {$IFDEF VER190}'designide110.bpl';{$ENDIF}
                {$IFDEF VER200}'designide120.bpl';{$ENDIF}
                {$IFDEF VER210}'designide140.bpl';{$ENDIF}
                {$IFDEF VER220}'designide150.bpl';{$ENDIF}
                {$IFDEF VER230}'designide160.bpl';{$ENDIF}
                {$IFDEF VER240}'designide170.bpl';{$ENDIF}
                {$IFDEF VER250}'designide180.bpl';{$ENDIF}
                {$IFDEF VER260}'designide190.bpl';{$ENDIF}
                {$IFDEF VER270}'designide200.bpl';{$ENDIF}
                {$IFDEF VER280}'designide210.bpl';{$ENDIF}
                {$IFDEF VER290}'designide220.bpl';{$ENDIF}
                {$IFDEF VER300}'designide230.bpl';{$ENDIF}
                {$IFDEF VER310}'designide240.bpl';{$ENDIF}
                {$IFDEF VER320}'designide250.bpl';{$ENDIF}

initialization
  CreateCurrentComponentAddr := GetProcAddress(GetModuleHandle(PackageName), TargetName);
  if CreateCurrentComponentAddr = nil then Exit;
  @TrampolineCreateCurrentComponent := InterceptCreate(CreateCurrentComponentAddr, @MyCreateCurrentComponent);
  Hooked := True;
finalization
  if not Hooked then Exit;
  InterceptRemove(@TrampolineCreateCurrentComponent);
end.
